; Text importing program in AutoLisp
; January 1987   Bryan Hackney
; All Rights Reserved
;
; May be modified in any way and used for any purpose
; May not be distributed in modified form without consent
;
; If you use this and find it useful, please send $5.00 to
; Goetting & Associates
; 70 N.E. Loop 410
; Suite 500
; San Antonio, TX  78216
; ATTN: Bryan Hackney
; 


(defun readruler ()                                       ; read ruler function
    (command "dir" "*.rul")                               ; get directory
    (setq rfile (open (getstring "\nRuler file: ") "r"))  ; open ruler file
    (setq cols    (atoi (read-line rfile)))               ; read number of cols
    (setq spc     (atof (read-line rfile)))               ; read spacing
    (setq ruler   (read (read-line rfile)))               ; read ruler line
    (setq just    (read (read-line rfile)))               ; read justification
    (close rfile))                                        ; close ruler file

(defun c:import ()                                        ; import function
    (readruler)                                           ; read ruler
    (setq fname (getstring "Text file name: "))
    (princ "\nThere are ") (princ cols) (princ " column\(s\)")
    (princ "\nLine spacing is ") (princ spc)
    (setq tfile (open fname "r"))                         ; open text file
    (setq p1 (getpoint "\nStarting point: ") x1 (car p1) y (cadr p1) loop 2)
    (readln))

;234567890123456789012345678901234567890123456789012345678901234567890123456789

(defun readln ()             ; pseudo-recursive function to avoid deep recursion
  (cond
    (
      (equal loop 0
      )
      (setq loop 2
      )
      (command "script" "readln"    ;READLN.SCR must be present
      )
    )
    (
      (setq tstring
        (read-line tfile
        )
      )
      (setq tline
        (read tstring
        )
      )
      (readit
      )
      (setq loop 
        (- loop 1 
        )
      )
      (readln
      )
    )
    (T
      (close tfile
      )
      (setq rfile nil cols nil spc nil ruler nil just nil fname nil tfile nil
            p1 nil x1 nil y nil loop nil tstring nil tline nil n nil
      )
      (gc
      )
    )
  )
)


(defun readit ()
  (setq n 0
  )
  (while
    (<= n
      (- cols 1
      )
    )
    (setq t
      (nth n tline
      )
      j
      (if
        (equal
          (nth n just
          )
          "L"
        )
        " "
        (nth n just
        )
      )
    )
    (command "text" j
      (list
        (+ x1
          (nth n ruler
          )
        )
        y
      )
      "" ""  t
    )
    (setq n
      (+ n 1
      )
    )
  )
  (setq y
    (- y spc
    )
  )
  nil
)

;234567890123456789012345678901234567890123456789012345678901234567890123456789

